package com.zhongzheng.modules.exam.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.exam.bo.ExamNumberGoodsAddBo;
import com.zhongzheng.modules.exam.bo.ExamNumberGoodsQueryBo;
import com.zhongzheng.modules.exam.bo.ExamNumberGoodsEditBo;
import com.zhongzheng.modules.exam.domain.ExamNumberGoods;
import com.zhongzheng.modules.exam.mapper.ExamNumberGoodsMapper;
import com.zhongzheng.modules.exam.vo.ExamNumberGoodsVo;
import com.zhongzheng.modules.exam.service.IExamNumberGoodsService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 考试配置绑定商品Service业务层处理
 *
 * @author ruoyi
 * @date 2021-12-06
 */
@Service
public class ExamNumberGoodsServiceImpl extends ServiceImpl<ExamNumberGoodsMapper, ExamNumberGoods> implements IExamNumberGoodsService {

    @Override
    public ExamNumberGoodsVo queryById(Long id){
        ExamNumberGoods db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ExamNumberGoodsVo.class);
    }

    @Override
    public List<ExamNumberGoodsVo> queryList(ExamNumberGoodsQueryBo bo) {
        LambdaQueryWrapper<ExamNumberGoods> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getExamNumberId() != null, ExamNumberGoods::getExamNumberId, bo.getExamNumberId());
        lqw.eq(bo.getGoodsId() != null, ExamNumberGoods::getGoodsId, bo.getGoodsId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamNumberGoodsVo> entity2Vo(Collection<ExamNumberGoods> collection) {
        List<ExamNumberGoodsVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamNumberGoodsVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ExamNumberGoods> page = (Page<ExamNumberGoods>)collection;
            Page<ExamNumberGoodsVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ExamNumberGoodsAddBo bo) {
        ExamNumberGoods add = BeanUtil.toBean(bo, ExamNumberGoods.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ExamNumberGoodsEditBo bo) {
        ExamNumberGoods update = BeanUtil.toBean(bo, ExamNumberGoods.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ExamNumberGoods entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<ExamNumberGoodsVo> ListExamNumber(Long examNumberId) {

        return  baseMapper.ListExamNumber(examNumberId);
    }

    @Override
    public List<ExamNumberGoodsVo> listGoods(ExamNumberGoodsQueryBo bo) {
        return baseMapper.listGoods(bo);
    }
}
